#include <stdlib.h>
#include <stdio.h>

#define DIM     3
#define NATOMS  300
#define ZDROJ   "oxygen"
#define DELTAT  0.001

class type_atom
{
private:
	double *r;	// suradnice atomu
	double *v;	// rychlosti
	double *f;	// sily posobiace na atom
public:
	type_atom();	// konstruktor - deklaracia
	void operator<(FILE *source);
	void operator>(FILE *target){fprintf(target,"%.10g  %.10g  %.10g\n", v[0], v[1], v[2]);}
};

type_atom::type_atom()	// konstruktor - definicia
{
	r = new (double)[DIM];
	v = new (double)[DIM];
	f = new (double)[DIM];
}

void type_atom::operator<(FILE *source)	// pretazenie operatora <
{
    int k;
    double *tmp;
    double *rold = new (double)[DIM];

    tmp  = rold;
    rold = r;
    r    = tmp;

    fscanf(source, "%lg%lg%lg%", &r[0], &r[1], &r[2]);

    for (k=0; k<DIM; ++k) v[k] = (r[k]-rold[k])/DELTAT;

    delete (rold);
}

class type_system	// konstruktor
{
private:
	type_atom *atom;
public:
        type_system(char *startfrom);
};

type_system::type_system(char *startfrom)
{
	atom = new (type_atom)[NATOMS];
	
	FILE *source = fopen(startfrom,"r");

	int i;
	for (i=0; i<NATOMS; ++i) atom[i]<source;	// cas t=0
	for (i=0; i<NATOMS; ++i) atom[i]<source;	// cas t=1

	fclose(source);

	for (i=0; i<NATOMS; ++i) atom[i]>stdout;	// vypis rychlosti na stdout 
}

type_system O2(ZDROJ);

main(int argc, char *argv[])
{
;
}
